import { Notification } from 'rxjs';
export declare const enum RxNotificationKind {
    Suspense = "suspense",
    Next = "next",
    Error = "error",
    Complete = "complete"
}
export declare type RxNotificationValue = 'value' | 'hasValue';
export interface RxNextNotification<T> extends Pick<Notification<T>, RxNotificationValue> {
    kind: RxNotificationKind;
    error: boolean;
    complete: boolean;
}
export interface RxSuspenseNotification<T> extends Pick<Notification<T>, RxNotificationValue> {
    kind: RxNotificationKind.Suspense;
    error: false;
    complete: false;
}
export interface RxErrorNotification<T> extends Pick<Notification<T>, RxNotificationValue> {
    kind: RxNotificationKind.Error;
    error: any;
    complete: false;
}
export interface RxCompleteNotification<T> extends Pick<Notification<T>, RxNotificationValue> {
    kind: RxNotificationKind.Complete;
    complete: boolean;
    error: false;
}
export declare type RxNotification<T> = RxNextNotification<T> | RxSuspenseNotification<T> | RxErrorNotification<T> | RxCompleteNotification<T>;
